#include <windows.h>

#include "ReplacementList.h"
#include "PEEngine.h"
#include "Config.h"
#include "debugio.h"
#include "Log.h"

static bool PrepraviIAT(HMODULE hMod) {
	BYTE *exe = (BYTE*)hMod;
	const DLL_functions *df;
	IMAGE_THUNK_DATA *thunk;
	const FuncPair *fp;
	HMODULE modul;
	void *origf;

	IMAGE_IMPORT_DESCRIPTOR *iid = FindImportDescriptor(exe);
	if (!iid)
		return false;

#ifdef _DEBUG
	ListThunks(exe, iid);
#endif

	for (df = za_zamjenu; df->dll_name; ++df) {
		thunk = FindThunk(exe, iid, df->dll_name);
		if (!thunk) continue;

		modul = GetModuleHandle(df->dll_name);

		for (fp = df->functions; fp->origf; ++fp) {
			if (!FunctionMonitoringEnabled(fp->origf))
				continue;

			origf = (void*)GetProcAddress(modul, fp->origf);
			if (origf) {
				dprintf("Zamijenjujem %s (%p) sa %p.\n", fp->origf, origf, fp->newf);
				ZakaciFju(thunk, origf, fp->newf);
			} else {
				wprintf("Nije nadjena originalna funkcija %s!\n", fp->origf);
			}
		}
	}

	dputs("Gotovo prepravljanje!");

	return true;
}

static void suicide() {
	eputs("Ubijam!");
	TerminateProcess(GetCurrentProcess(), 0xFFFFFFFF);
}

extern "C" BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			dputs("Koristi se debug verzija DLL-a.");
			dprintf("DLL: 0x%p, EXE: 0x%p\n", hModule, GetModuleHandle(NULL));

			if (!LoadConfig()) {
				MessageBox(NULL, "Nedostaje konfiguracijska datoteka!", NULL, MB_ICONERROR);
				suicide();
				return FALSE;
			}

			if (!InitLog()) {
				MessageBox(NULL, "Ne mogu pripremiti log!", NULL, MB_ICONERROR);
				suicide();
				return FALSE;
			}

			if (!PrepraviIAT(GetModuleHandle(NULL))) {
				MessageBox(NULL, "Problem pri prepravljanju IAT!", "Greka!", MB_ICONERROR);
				suicide();
				return FALSE;
			}

			break;

		case DLL_PROCESS_DETACH:
			CloseLog();
			dputs("Zatvaram nAPI.dll.");
			break;
	}

    return TRUE;
}
