#ifndef _LOG_H_
#define _LOG_H_

#include <vector>
#include <string>

using namespace std;

class ReportElement {
	public:
		ReportElement(const string &n = string(), const string &v = string()) : name(n), value(v) {}

		string name, value;
};

class Report {
	public:
		Report(const string &function_name) : fname(function_name) {}

		void AddString(const string &name, const char *s);
		void AddString(const string &name, const string &s);
		void AddHex(const string &name, unsigned int hex);
		void AddPtr(const string &name, void *ptr);
		void AddInt(const string &name, int broj);
		void AddUInt(const string &name, UINT broj);
		void AddDouble(const string &name, double broj);
		void AddElement(const ReportElement &el);

		void WriteToFile(FILE *f) const;

	private:
		string fname;
		vector<ReportElement> elems;

		static string FormatString(const char *s);
};

void AddToLog(const Report &r);
bool InitLog();
void CloseLog();

#endif
