#include <stdio.h>

#include "PEEngine.h"
#include "debugio.h"

// trai .idata odjeljak, tj. odjeljak sa importanim DLL-ovima
IMAGE_IMPORT_DESCRIPTOR * FindImportDescriptor(BYTE *exe) {
	IMAGE_DOS_HEADER *DosHeader = (IMAGE_DOS_HEADER*)exe;
	IMAGE_NT_HEADERS *NtHeader = (IMAGE_NT_HEADERS*)(exe + DosHeader->e_lfanew);

	if (NtHeader->Signature != IMAGE_NT_SIGNATURE) {
		MessageBox(NULL, "Program nema NT zaglavlje", NULL, MB_ICONERROR);
		return NULL;
	}

	unsigned long ImportEntryOffset = NtHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	return (IMAGE_IMPORT_DESCRIPTOR*)(exe + ImportEntryOffset);
}

void ListThunks(BYTE *exe, const IMAGE_IMPORT_DESCRIPTOR *iid) {
	printf("Imported DLLs:\n");
	for (; iid->Name; ++iid)
		printf(" %s\n", (char*)(exe + iid->Name));
	printf("----\n\n");
}

// trai pododjeljak sa funkcijama iz zadanog DLL-a
IMAGE_THUNK_DATA * FindThunk(BYTE *exe, const IMAGE_IMPORT_DESCRIPTOR *iid, const char *dllname) {
	dprintf("Trazim: %s...\n", dllname);
	for (; iid->Name; ++iid) {
		char *nam = (char*)(exe + iid->Name);
		if (!lstrcmpi(nam, dllname)) {
			dputs("Nasao!");
			return (IMAGE_THUNK_DATA*)(exe + iid->FirstThunk);
		}
	}
	dputs("Nije nadjen!");
	return NULL;
}

bool ZakaciFju(IMAGE_THUNK_DATA *thunk, void *old_f, void *new_f) {
	DWORD oldflags, dw;

	for (; thunk->u1.Function; ++thunk) {
		if (*(void**)((void*)&thunk->u1.Function) == old_f) {
			// omoguci pisanje po tom segmentu memorije
			if (!VirtualProtect(&thunk->u1.Function, sizeof(new_f), PAGE_READWRITE, &oldflags)) {
				eputs("VirtualProtect failed!!!");
				return false;
			}

			*((void**)((void*)&thunk->u1.Function)) = new_f;

			// vrati stare privilegije
			VirtualProtect(&thunk->u1.Function, sizeof(new_f), oldflags, &dw);

			return true;
		}
	}

	wprintf("Nije nadjena fja %p!\n", old_f);
	return false;
}
