#define _WIN32_WINNT   0x0400
#include "ReplacementList.h"
#include "MemoryAPIOverride.h"
#include "ThreadAPIOverride.h"
#include "SocketAPIOverride.h"
#include "FileAPIOverride.h"

static const FuncPair user32_functions[] = {
	{NULL, NULL}
};

static const FuncPair kernel32_functions[] = {
	{"GlobalAlloc", (void*)nAPI_GlobalAlloc},
	{"GlobalFree", (void*)nAPI_GlobalFree},
	{"GetModuleHandleA", (void*)nAPI_GetModuleHandleA},
	{"GetModuleHandleW", (void*)nAPI_GetModuleHandleW},
	{"CreateThread", (void*)nAPI_CreateThread},
	{"CloseHandle", (void*)nAPI_CloseHandle},
	{"ExitThread", (void*)nAPI_ExitThread},
	{"CreateFileA", (void*)nAPI_CreateFileA},
	{"CreateFileW", (void*)nAPI_CreateFileW},
	{"ReadFile", (void*)nAPI_ReadFile},
	{"WriteFile", (void*)nAPI_WriteFile},
	{"DeleteFileA", (void*)nAPI_DeleteFileA},
	{"DeleteFileW", (void*)nAPI_DeleteFileW},
	{"MoveFileA", (void*)nAPI_MoveFileA},
	{"MoveFileW", (void*)nAPI_MoveFileW},
	{"CopyFileExA", (void*)nAPI_CopyFileExA},
	{"CopyFileExW", (void*)nAPI_CopyFileExW},
	{"CreateDirectoryA", (void*)nAPI_CreateDirectoryA},
	{"CreateDirectoryW", (void*)nAPI_CreateDirectoryW},
	{"RemoveDirectoryA", (void*)nAPI_RemoveDirectoryA},
	{"RemoveDirectoryW", (void*)nAPI_RemoveDirectoryW},
	{NULL, NULL}
};

static const FuncPair ws2_32_functions[] = {
	{"socket", (void*)nAPI_socket},
	{"send", (void*)nAPI_send},
	{"recv", (void*)nAPI_recv},
	{"accept", (void*)nAPI_accept},
	{"bind", (void*)nAPI_bind},
	{"listen", (void*)nAPI_listen},
	{"connect", (void*)nAPI_connect},
	{"closesocket", (void*)nAPI_closesocket},
	{"sendto", (void*)nAPI_sendto},
	{"recvfrom", (void*)nAPI_recvfrom},
	{NULL, NULL}
};

const DLL_functions za_zamjenu[] = {
	{"user32.dll", user32_functions},
	{"kernel32.dll", kernel32_functions},
	{"ws2_32.dll", ws2_32_functions},
	{"wsock32.dll", ws2_32_functions},
	{NULL, NULL}
};
