#ifndef _DEBUGIO_H_
#define _DEBUGIO_H_

#include <stdio.h>

#define ERR_PREFIX	"nAPI-ERROR: "
#define WRN_PREFIX	"nAPI-Warning: "

#define eprintf(s, ...) fprintf(stderr, ERR_PREFIX s, __VA_ARGS__)
#define eputs(s) fputs(ERR_PREFIX s "\n", stderr)
#define wprintf(s, ...) fprintf(stderr, WRN_PREFIX s, __VA_ARGS__)
#define wputs(s) fputs(WRN_PREFIX s "\n", stderr)

#ifdef _DEBUG
# define dprintf(s, ...) printf("nAPI: " s, __VA_ARGS__)
# define dputs puts
#else
# define dprintf(...)
# define dputs(...)
#endif

#endif
