﻿using System;
using System.IO;
using System.Collections;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace nAPI
{
    class Konfiguracija
    {
        private TreeView tv;
        private ArrayList listovi = new ArrayList();

        public Konfiguracija(TreeView tv)
        {
            this.tv = tv;

            /* Za svaki root čvor u treeView1 (treeView1.Nodes) pozovi metodu GetNodes,
             * tako da se u ArrayList listovi na kraju nalaze svi listovi stabla treeView1.
             */
            foreach (TreeNode tn in tv.Nodes)
            {
                GetNodes((TreeNode)tn);
            }
        }

        /* Metoda GetNodes u globalnu varijablu ArrayList listovi dodaje listove (krajnje čvorove)
         * koji pripadaju čvoru koji je predan kao argument.
         */
        private void GetNodes(TreeNode node)
        {
            if (node.Nodes.Count > 0)
            {
                foreach (TreeNode ChildNode in node.Nodes)
                {
                    GetNodes(ChildNode);
                }
            }
            else
            {
                listovi.Add(node);
            }
        }


        public int zapisiKofiguraciju()
        {
            /* Sljedeći odjeljak u konfiguracijsku datoteku zapisuje vrijednosti 
             * u ovisnosti o odabranim čvorovima u stablu treeView1 (gledaju se
             * samo krajnji čvorovi, tj. listovi).
             */
            string konfRedak = "";
            string pom;

            int brojac = 0;

            TextWriter tw = new StreamWriter("nAPI.conf");

            foreach (TreeNode tn in listovi)
            {
                if (tn.Checked == true)
                {
                    if (tn.Text == "statistika")
                        pom = tn.Tag.ToString();
                    else
                        pom = tn.Text;


                    if (konfRedak == "") // Vrijedi samo za prvi čvor
                    {
                        konfRedak += tn.Parent.Text + " " + pom;
                    }
                    else if (konfRedak.Contains(tn.Parent.Text))
                    {
                        konfRedak += " " + pom;
                    }
                    else
                    {
                        konfRedak = konfRedak.Trim();

                        for (int i = 1; i < konfRedak.Length; i++)
                        {
                            if (konfRedak[i - 1] == ' ' && konfRedak[i] != ' ')
                                brojac++;
                        }

                        konfRedak = konfRedak.Insert(0, brojac.ToString() + " ");
                        tw.WriteLine(konfRedak);

                        // Početak novog retka u konfiguraciji
                        brojac = 0;
                        konfRedak = tn.Parent.Text + " " + pom;
                    }
                }
            }

            if (konfRedak != "")
            {
                konfRedak = konfRedak.Trim();

                for (int i = 1; i < konfRedak.Length; i++)
                {
                    if (konfRedak[i - 1] == ' ' && konfRedak[i] != ' ')
                        brojac++;
                }

                konfRedak = konfRedak.Insert(0, brojac.ToString() + " ");
                tw.WriteLine(konfRedak);
            }
            
            tw.Close();

            return brojac;
        }
        
        
        public string pronadjiPotrebneKontrole()
        {
            string buffer = "";

            foreach (TreeNode tn in listovi)
            {
                if (tn.Checked)
                {
                    if (!buffer.Contains(tn.Parent.Parent.Text)) 
                        buffer += "\r\n" + tn.Parent.Parent.Text + " ";

                    if (tn.Text == "statistika")
                        buffer += tn.Parent.Text + " ";
                }
            }

            buffer = buffer.Trim();
            return buffer;
        }


    }
}
