﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace nAPI
{
    class Log
    {
        private string logPath;

        private string ispisAkt = "";
        private string ispisDat = "";
        private string ispisMre = "";
        private string ispisMem = "";

        private string statDat = "";
        private string statMre = "";
        private string statMem = "";
        
        public Log(string nazivAplikacije)
        {
            this.logPath = Environment.CurrentDirectory + "\\nAPI-" + nazivAplikacije + ".txt";
        }

        public void ucitajLog()
        {
            int brOpcFje = 0;
            int brRedStr = 0;

            string dioLoga = "";
            string tipZapisa = "";
            string buffer;

            try
            {
                TextReader tr = new StreamReader(logPath);

                do
                {
                    do // Preskoči prazne redove
                    {
                        buffer = tr.ReadLine();
                    } while (buffer == "");

                    if (buffer != null)
                    {
                        /* U brOpcFje učitaj broj nadziranih karakteristika funkcije iz loga koja 
                         * je trenutno u obradi*/
                        brOpcFje = int.Parse(buffer.Substring(0, buffer.IndexOf(' ')));

                        buffer = buffer.Substring(buffer.IndexOf(' ') + 1);
                        tipZapisa = buffer;

                        dioLoga += buffer + "\r\n";

                        while (brOpcFje > 0)
                        {
                            buffer = tr.ReadLine();

                            // Ako u logu naiđemo na string (koji može imati više redova)
                            if (buffer.Contains("\""))
                            {
                                brRedStr = buffer.IndexOf("\"") + 2;
                                // Broj redova stringa
                                brRedStr = int.Parse(buffer.Substring(brRedStr)); 

                                buffer = buffer.Substring(0, buffer.IndexOf("\""));
                                dioLoga += buffer;

                                while (brRedStr > 0)
                                {
                                    buffer = tr.ReadLine();
                                    dioLoga += buffer + "\r\n";

                                    brRedStr--;
                                }

                                // Pročitaj red sa zadnjim dvostrukim navodnikom
                                tr.ReadLine();
                            }
                            else if (buffer.Contains("sum_read") || buffer.Contains("num_read") || buffer.Contains("avg_read") ||
                                buffer.Contains("sum_write") || buffer.Contains("num_write") || buffer.Contains("avg_written"))
                            {
                                statDat += tipZapisa + " " + buffer + "\r\n";
                                dioLoga += buffer + "\r\n";
                            }
                            else if (buffer.Contains("brojslanja") || buffer.Contains("avgposl") || buffer.Contains("ukposlano") ||
                                buffer.Contains("brojprimanja") || buffer.Contains("avgprim") || buffer.Contains("ukprimljeno"))
                            {
                                statMre += tipZapisa + " " + buffer + "\r\n";
                                dioLoga += buffer + "\r\n";
                            }
                            else if (buffer.Contains("sum:") || buffer.Contains("num:") || buffer.Contains("avg:"))
                            {
                                statMem += tipZapisa + " " + buffer + "\r\n";
                                dioLoga += buffer + "\r\n";
                            }
                            else
                            {
                                dioLoga += buffer + "\r\n";
                            }
                            brOpcFje--;
                        }
                    }

                    if (dioLoga != "")
                    {
                        dioLoga += "\r\n";
                        ispisAkt += dioLoga;
                        dodajUIspise(dioLoga, tipZapisa);
                    }

                    dioLoga = "";
                }
                while (buffer != null);

                tr.Close();

                File.Move(logPath, logPath.Replace(".txt",
                    DateTime.Now.ToString(" dd/MM/yyyy h.mm.ss") + ".txt"));
                //File.Delete(logPath);
            }

            catch (FileNotFoundException)
            {
                MessageBox.Show("Proces ne može biti pokrenut u nadziranom načinu!",
                    "Neuspjeh!",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Exclamation);
            }

        }


        private void dodajUIspise(string zapis, string vrstaZapisa)
        {
            if (vrstaZapisa.Equals("GlobalAlloc") || vrstaZapisa.Equals("GlobalFree"))
            {
                ispisMem += zapis;
            }
            else if (vrstaZapisa.Equals("socket") || vrstaZapisa.Equals("accept") || 
                vrstaZapisa.Equals("bind") || vrstaZapisa.Equals("connect") || 
                vrstaZapisa.Equals("listen") || vrstaZapisa.Equals("recv") || 
                vrstaZapisa.Equals("send") || vrstaZapisa.Equals("recvfrom") || 
                vrstaZapisa.Equals("sendto") || vrstaZapisa.Equals("closesocket"))
            {
                ispisMre += zapis;
            }
            else if (vrstaZapisa.Equals("CreateFile") || vrstaZapisa.Equals("DeleteFile") ||
                 vrstaZapisa.Equals("ReadFile") || vrstaZapisa.Equals("WriteFile") ||
                 vrstaZapisa.Equals("MoveFile") || vrstaZapisa.Equals("CopyFileEx") ||
                 vrstaZapisa.Equals("CloseHandle") || vrstaZapisa.Equals("CreateDirectory") ||
                 vrstaZapisa.Equals("RemoveDirectory"))
            {
                ispisDat += zapis;
            }		    	
        }


        public string ispisiUcitaniLog(short indeksTaba)
        {
            switch (indeksTaba)
            {
                case 1:                    
                        return ispisAkt;
                case 2:
                        return ispisDat;
                case 3:
                        return ispisMre;
                case 4:
                        return ispisMem;
                default:
                    return "";
            }
        }


        public string ispisiStat(short indeksTaba)
        {
            switch (indeksTaba)
            {
                case 2:
                        return statDat;
                case 3:
                        return statMre;
                case 4:
                        return statMem;
                default:
                    return "";
            }
        }

    }
}
