#include<stdio.h>
#include<winsock2.h>
#include<windows.h>
#include<ws2tcpip.h>
#include <stdlib.h>

#pragma comment(lib, "wsock32.lib")

#define ADRESA "127.0.0.1"
#define HIVER 2
#define LOVER 2
#define PORT "27005"
#define DEFAULT_BUFLEN 512
#define SENDBUF 128

int main () {
	
	int getinfo, iResult;
	WSADATA wsadata;
	WORD wVersionRequested = MAKEWORD(HIVER, LOVER);
	struct addrinfo *result = NULL,
                *ptr = NULL,
                hints;

	SOCKET ConnectSocket = INVALID_SOCKET;
	char *adresa = ADRESA, *port = PORT;

	int recvbuflen = DEFAULT_BUFLEN;

	char sendbuf[SENDBUF] = "Socket proba";
	char recvbuf[DEFAULT_BUFLEN];
	

	if (WSAStartup(wVersionRequested, &wsadata)!= 0) {
		printf("Nije moguce provjeriti verziju socketa\n");
		WSACleanup();
		return 1;
	}
	

	if ( LOBYTE( wsadata.wVersion ) != HIVER ||
         HIBYTE( wsadata.wVersion ) != LOVER ) {
			printf("Ne mogu naci winsock2.dll\n");
			WSACleanup();
			return 1;   
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	
	if(getaddrinfo(adresa, port, &hints, &result)) {
		printf("Can't get address info\n");
		WSACleanup();
		return 1;
	}

	for(ptr=result; ptr != NULL ;ptr=ptr->ai_next) {

        // Create a SOCKET for connecting to server
        ConnectSocket = socket(ptr->ai_family, ptr->ai_socktype, 
            ptr->ai_protocol);
        if (ConnectSocket == INVALID_SOCKET) {
            printf("Error at socket(): %ld\n", WSAGetLastError());
            freeaddrinfo(result);
            WSACleanup();
            return 1;
        }

        // Connect to server.
        iResult = connect( ConnectSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
        if (iResult == SOCKET_ERROR) {
            closesocket(ConnectSocket);
            ConnectSocket = INVALID_SOCKET;
            continue;
        }
        break;
    }

	freeaddrinfo(result);

	 if (ConnectSocket == INVALID_SOCKET) {
        printf("Unable to connect to server!\n");
        WSACleanup();
        return 1;
    }

	printf("Connected!\n");

	iResult = send(ConnectSocket, sendbuf, sizeof(sendbuf), 0);
	
	if(iResult == SOCKET_ERROR) {
		printf("send failed\n");
		closesocket(ConnectSocket);
        WSACleanup();
        return 1;
	}

	iResult = shutdown(ConnectSocket, SD_SEND);
    if (iResult == SOCKET_ERROR) {
        printf("shutdown failed: %d\n", WSAGetLastError());
        closesocket(ConnectSocket);
        WSACleanup();
        return 1;
    }

	// Receive data until the server closes the connection
	do {

		iResult = recv(ConnectSocket, recvbuf, recvbuflen, 0);
		if ( iResult > 0 )
			printf("Bytes received: %d\n", iResult);
		else if ( iResult == 0 )
			printf("Connection closed\n");
		else
			printf("recv failed: %d\n", WSAGetLastError());

	} while( iResult > 0 );

	closesocket(ConnectSocket);
	WSACleanup();

	system("PAUSE");

	return 0;

}