#include<stdio.h>
#include<winsock2.h>
#include<windows.h>
#include<ws2tcpip.h>
#include<stdlib.h>

#pragma comment(lib, "wsock32.lib")

#define ADRESA "127.0.0.1"
#define HIVER 2
#define LOVER 2
#define PORT "27015"
#define DEFAULT_BUFLEN 512

int main() {

	WSADATA wsadata;
	WORD wVersionRequested = MAKEWORD(HIVER, LOVER);
	ADDRINFOA *result, hints;
	SOCKET ListenSocket = INVALID_SOCKET, ClientSocket = INVALID_SOCKET;
	int iResult, iSendResult;
	char recvbuf[DEFAULT_BUFLEN], sendbuf[50];
	char *adresa = ADRESA, *port = PORT;

	if(WSAStartup(wVersionRequested, &wsadata)) {
		printf("Nije moguce provjeriti verziju socketa\n");
		WSACleanup();
		return 1;
	}

	
	if ( LOBYTE( wsadata.wVersion ) != LOVER ||
         HIBYTE( wsadata.wVersion ) != HIVER ) {
			printf("Ne mogu naci winsock2.dll\n");
			WSACleanup();
			return 1;   
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags = AI_PASSIVE; 

	// Resolve the local address and port to be used by the server
	iResult = getaddrinfo(NULL, port, &hints, &result);
	if ( iResult != 0 ) {
		printf("getaddrinfo failed: %d\n", iResult);
		WSACleanup();
		return 1;
	}

	//Create socket
	ListenSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
    if (ListenSocket == INVALID_SOCKET) {
        printf("socket failed: %ld\n", WSAGetLastError());
        freeaddrinfo(result);
        WSACleanup();
        return 1;
	}

	printf("Socket created...\n");

	//set up TCP listening socket
	if(bind(ListenSocket, result->ai_addr, result->ai_addrlen)) {
		printf("Binding unsuccessful, error: %d\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 1;
	}

	printf("Socket bound...\n");

	freeaddrinfo(result);

	printf("Listening socket...\n");
	
	iResult = listen(ListenSocket, SOMAXCONN); //SOMAXCONN - The maximum length to which the queue of pending connections may grow.
    if (iResult == SOCKET_ERROR) {
        printf("listen failed: %d\n", WSAGetLastError());
        closesocket(ListenSocket);
        WSACleanup();
		system("PAUSE");
        return 1;
    }

    // Accept a client socket
    ClientSocket = accept(ListenSocket, result->ai_addr, (int*)&result->ai_addrlen);
    if (ClientSocket == INVALID_SOCKET) {
        printf("accept failed: %d\n", WSAGetLastError());
        closesocket(ListenSocket);
        WSACleanup();
        return 1;
    }

	printf("Client socket accepted!\n");

	closesocket(ListenSocket);

	// Receive until the peer shuts down the connection
    do {

        iResult = recv(ClientSocket, recvbuf, DEFAULT_BUFLEN, 0);
        if (iResult > 0) {
            printf("Bytes received: %d\n", iResult);
			printf("%s\n", recvbuf);

			//*sendbuf = "dobio poruku";
			strcpy(sendbuf, "dobio poruku");

        // Echo the buffer back to the sender
           iSendResult = send(ClientSocket, sendbuf, sizeof(sendbuf), 0 );
            if (iSendResult == SOCKET_ERROR) {
                printf("send failed: %d\n", WSAGetLastError());
                closesocket(ClientSocket);
                WSACleanup();
                return 1;
            }
			
        }
        else if (iResult == 0)
            printf("Connection closing...\n");
        else  {
            printf("recv failed: %d\n", WSAGetLastError());
            closesocket(ClientSocket);
            WSACleanup();
            return 1;
        }

    } while (iResult > 0);

    // shutdown the connection since we're done
    iResult = shutdown(ClientSocket, SD_SEND);
    if (iResult == SOCKET_ERROR) {
        printf("shutdown failed: %d\n", WSAGetLastError());
        closesocket(ClientSocket);
        WSACleanup();
        return 1;
    }

    // cleanup
    closesocket(ClientSocket);
    WSACleanup();

	system("PAUSE");

    return 0;
}