#define _WIN32_WINNT   0x0400
#include <windows.h>
#include <iostream>
using namespace std;

/*ubacujem funkciju koja na temelju zadanih parametara
 *poziva funkciju MoveFile i ispisuje potrebne parametre u konzolu
 */
void premjesti(LPCSTR lpExistingFileName, LPCSTR lpNewFileName, 
			   int broj, char* oldf, char* newf){
	bool rez;
	cout << broj << " poziv funkcije MoveFile sa sljedecim parametrima" << endl;
	cout << "oldfilename = " << oldf << endl << "newfilename = " << newf << endl;
	rez = MoveFile(lpExistingFileName, lpNewFileName);
	if(rez) cout << "Poziv je uspio, success = " << rez << endl;
	else{
		cout << "Poziv nije uspio, success = " << rez 
			<< endl << "Error: " << (unsigned int)GetLastError() << endl;
	}
}

/*funkcija del isto na temelju zadanih parametara
 *poziva funkciju DeleteFile i ispisuje potrebne
 *parametre u konzolu
 */
void del(LPCSTR lpFileName, char* file, int broj){
	bool rez;
	cout << broj << " poziv funkcije DeleteFile sa sljedecim parametrom:" << endl;
	cout << "file_name = " << file << endl;
	rez = DeleteFile(lpFileName);
	if(rez) cout << "Poziv je uspio, success = " << rez << endl;
	else{
		cout << "Poziv nije uspio, success = " << rez << endl 
			<< "Error: " << (unsigned int)GetLastError() << endl;
	}
}

/*funkcija kopiraj poziva funkciju CopyFileEx
 *i ispisuje sve potrebne parametre u konzolu
 */
void kopiraj(LPCSTR lpExistingFileName, LPCSTR lpNewFileName, 
			 LPPROGRESS_ROUTINE lpProgressRoutine,LPVOID lpData, LPBOOL pbCancel, 
			 DWORD dwCopyFlags, int broj, char* oldf, char* newf){
	bool rez;
	cout << broj << " poziv funkcije CopyFileEx sa sljedecim parametrima:" << endl;
	cout << "orginalfilename = " << oldf << endl << "newfilename = " << newf << endl;
	rez = CopyFileExA(lpExistingFileName, lpNewFileName, 
		lpProgressRoutine, lpData, pbCancel, dwCopyFlags);
	if(rez) cout << "Poziv je uspio, success = " << rez << endl;
	else{
		cout << "Poziv nije uspio, success = " << rez 
			<< endl << "Error: " << (unsigned int)GetLastError() << endl;
	}
}

void main(){
	int nastaviti;
	int brMove = 0, brDel = 0, brCopy = 0;
	char oldf[] = "test.txt";
	char newf[] = "test1.txt";
	char copf[] = "test2.txt";
	char buffer[] = "ovo bi trebao biti tekst";
	DWORD dwWritten = 0;
	LPDWORD lpWritten = &dwWritten;
	HANDLE hfile;
	//prvi pozivi funkcije DeleteFile koji ne bi trebao uspjeti
	del("test.txt", oldf, ++brDel);
	//prvi poziv funkcije MoveFile koji ne bi smio uspjeti jer datoteka ne bi trebala postojati
	premjesti("test.txt", "test1.txt", ++brMove, oldf, newf);
	hfile = CreateFile("test.txt", (GENERIC_READ | GENERIC_WRITE), 0, 
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hfile == INVALID_HANDLE_VALUE){
		cout << "Pokusaj stvaranja datoteke test.txt nije uspio" << endl;
		cout << "Error: " << (unsigned int)GetLastError() << endl;
	}else{
		cout << "Stvorena je datoteka test.txt" << endl;
		WriteFile(hfile, buffer, sizeof(buffer), lpWritten, NULL);
		cout << "Zapisujem u datoteku tekst: " << buffer << endl;
		del("test.txt", oldf, ++brDel);
		CloseHandle(hfile);
		cout << "Zatvaram handle datoteke test.txt" << endl;
	}
	kopiraj("test.txt", "test2.txt", NULL, NULL, FALSE,COPY_FILE_FAIL_IF_EXISTS, 
		++brCopy, oldf, copf);
	premjesti("test.txt", "test1.txt", ++brMove, oldf, newf);
	del("test1.txt", newf, ++brDel);
	premjesti("test2.txt", "test.txt", ++brMove, copf, oldf);
	//poziv CopyFileEx koji ne bi trebao uspjeti jer datoteka vise ne postoji pod tim imenom
	kopiraj("test2.txt", "test1.txt", NULL, NULL, FALSE, COPY_FILE_FAIL_IF_EXISTS, 
		++brCopy, copf, newf);
	del("test.txt", oldf, ++brDel);
	del("test1.txt", newf, ++brDel);
}