#include <windows.h>
#include <stdio.h>

HANDLE __stdcall napravi(LPCWSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, 
			 LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, 
			 DWORD dwFlagsAndAttributes, HANDLE hTemplateFile, int broj, char* datoteka){
	HANDLE hfile;
	printf("%d poziv funkcije CreateFile koristeci argumente:\n", broj);
	printf("file_name = %s\n", datoteka);
	printf("desired_access = 0x%08x\n", (unsigned int)dwDesiredAccess);
	printf("flags_attributes = 0x%08x\n", (unsigned int)dwFlagsAndAttributes);
	printf("htemplatefile = %p\n", hTemplateFile);
	hfile = CreateFileW(lpFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile);
	if ( hfile == INVALID_HANDLE_VALUE){
		printf("Pokusaj otvaranja datoteke nije uspio\n");
		printf("Error: %d\n", (unsigned int)GetLastError());
	}else{
		printf("CreateFile je vratio handle %p\n", hfile);
	}
	return hfile;
}
void zatvori(HANDLE hfile, int broj){
	BOOL rez;
	printf("%d poziv CloseHandle sa argumentima:\n", broj);
	printf("handle = %p\n", hfile);
	printf("type = FILE_HANDLE\n");
	rez = CloseHandle(hfile);
	if(!rez){
		printf("Poziv nije uspio, Error: %d\n", GetLastError());
		printf("success = %d\n", rez);
	}else printf("Poziv je uspio, success = %d\n", rez);
}

void main(){
	bool rez;
	char name[20] = "test.txt";
	char name2[20] = "test2.txt";
	char name3[20] = "testna_datoteka.txt";
	int broj = 0, brH = 0;
	HANDLE hfile, hfile2;
	LPCWSTR fname = L"test.txt";
	DWORD dwDesiredAccess = GENERIC_READ;
	DWORD dwShareMode = 0; //blokiram ponovno otvaranje datoteke
	LPSECURITY_ATTRIBUTES lpSecurityAttributes = NULL;
	DWORD dwCreationDisposition = CREATE_ALWAYS;
	DWORD dwFlagsAndAttributes = FILE_ATTRIBUTE_NORMAL;
	HANDLE hTemplateFile = NULL;
	hfile = napravi(fname, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile, ++broj, name);
	if ( hfile == INVALID_HANDLE_VALUE){
		hfile = NULL; //da ne dodje kasnije do greske u slucaju da se ovaj handle opet pokusa iskoristiti
	}
	/*pokusat cu opet otvoriti istu datoteku, sto ne bi trebalo proci, 
	 *dakle testiranje kako nAPI reagira kad funkcija ne uspije
	 */
	hfile2 = napravi(fname, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile, ++broj, name);
	if (hfile2 == INVALID_HANDLE_VALUE){
		hfile2 = NULL;
	}
	// prvi poziv CloseHandle
	zatvori(hfile, ++brH);
	//ponovni poziv sa promijenjenim argumentima
	LPCWSTR fname2 = L"test2.txt";
	dwDesiredAccess = (GENERIC_READ | GENERIC_WRITE);
	dwShareMode = FILE_SHARE_READ; //dopusteno da se opet otvori za citanje
	dwCreationDisposition = CREATE_ALWAYS;
	//datoteka ce biti izbrisana nakon sto se njezin handle zatvori
	dwFlagsAndAttributes = FILE_FLAG_DELETE_ON_CLOSE;
	hfile = napravi(fname2, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile, ++broj, name2);
	if (hfile == INVALID_HANDLE_VALUE){
		hfile = NULL;
	}
	//cetvrti poziv za otvorenu datoteku kojoj je ovaj put omoguceno citanje od strane drugih programa
	LPCWSTR fname3 = L"testna_datoteka.txt";
	dwDesiredAccess = GENERIC_WRITE;
	dwShareMode = FILE_SHARE_READ;
	dwCreationDisposition = CREATE_ALWAYS;
	hfile2 = napravi(fname3, dwDesiredAccess, dwShareMode, lpSecurityAttributes, 
		dwCreationDisposition, dwFlagsAndAttributes, hTemplateFile, ++broj, name3);
	if (hfile2 == INVALID_HANDLE_VALUE){
		hfile2 = NULL;
	}
	zatvori(hfile, ++brH);
	zatvori(hfile2, ++brH);
	//poziv CloseHandle za neispravni handle
	hfile2 = NULL; //postavljam handle koji su pokusati zatvoriti na null vrijednost
	zatvori(hfile2, ++brH);
	return;
}

