#include<stdio.h>
#include<winsock2.h>
#include<windows.h>
#include<ws2tcpip.h>
#include<stdlib.h>

#define ADRESA "127.0.0.1"
#define HIVER 2
#define LOVER 2
#define PORT "27015"
#define DEFAULT_BUFLEN 512

int main() {
	WSADATA wsadata;
	WORD wVersionRequested = MAKEWORD(HIVER, LOVER);
	ADDRINFOA *result, hints;
	SOCKET ListenSocket = INVALID_SOCKET, ClientSocket = INVALID_SOCKET;
	int iResult, iSendResult;
	char recvbuf[DEFAULT_BUFLEN], sendbuf[DEFAULT_BUFLEN];
	char *adresa = ADRESA, *port = PORT;

	if (WSAStartup(wVersionRequested, &wsadata)) {
		printf("Nema zahtijevane verzije winsock-a\n");
		WSACleanup();
		return 1;
	}

	if (LOBYTE(wsadata.wVersion) != LOVER ||
		HIBYTE(wsadata.wVersion) != HIVER) {
			printf("Ne mogu naci winsock2.dll\n");
			WSACleanup();
			return 1;   
	}

	ZeroMemory(&hints, sizeof(hints));
	// u hints stavljamo podatke o tipu socketa kakve server podrzava
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags = AI_PASSIVE; 

	// prevedi ime hosta u adresu
	iResult = getaddrinfo(NULL, port, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo() nije uspjela: %d\n", iResult);
		WSACleanup();
		return 1;
	}

	// kreiranje socketa
	ListenSocket = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
	if (ListenSocket == INVALID_SOCKET) {
		printf("Nije moguce kreirati socket: %ld\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 1;
	}

	printf("Socket kreiran...\n");

	// povezivanje socketa na zadani port i adresu
	if (bind(ListenSocket, result->ai_addr, result->ai_addrlen)) {
		printf("Bind() nije uspjela, error: %d\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 1;
	}

	printf("Socket povezan!\n");

	freeaddrinfo(result);

	printf("Slusam...\n");

	// socket ceka dolazece konekcije
	// SOMAXCONN - maksimalna velicina do koje moze rasti red konekcija koje cekaju
	iResult = listen(ListenSocket, SOMAXCONN);
	if (iResult == SOCKET_ERROR) {
		printf("Slusanje nije uspjelo: %d\n", WSAGetLastError());
		closesocket(ListenSocket);
		WSACleanup();
		return 1;
	}

	// prihvati klijentov socket
	ClientSocket = accept(ListenSocket, NULL, NULL);
	if (ClientSocket == INVALID_SOCKET) {
		printf("Prihvacanje neuspjelo: %d\n", WSAGetLastError());
		closesocket(ListenSocket);
		WSACleanup();
		return 1;
	}

	printf("Klijentov socket prihvacen!\n");

	closesocket(ListenSocket);

	// primaj podatke sve dok klijent ne zatvori konekciju
	do {
		iResult = recv(ClientSocket, recvbuf, DEFAULT_BUFLEN, 0);
		if (iResult > 0) {
			printf("Primljeno byteova: %d\n", iResult);
			printf("Primljeno: %s\n", recvbuf);

			strcpy(sendbuf, "dobio poruku");

			// salji podatke klijentu
			iSendResult = send(ClientSocket, sendbuf, sizeof(sendbuf), 0 );
			if (iSendResult == SOCKET_ERROR) {
				printf("Podaci nisu poslani: %d\n", WSAGetLastError());
				closesocket(ClientSocket);
				WSACleanup();
				return 1;
			}
		}
		else if (iResult == 0)
			printf("Zatvaram konekciju...\n");
		else  {
			printf("Primanje neuspjesno: %d\n", WSAGetLastError());
			closesocket(ClientSocket);
			WSACleanup();
			return 1;
		}

	} while (iResult > 0);

	// gasenje konekcije kad je gotovo
	// shutdown() onemogucuje slanje ili primanje podataka, ali ne zatvara socket
	iResult = shutdown(ClientSocket, SD_SEND);
	if (iResult == SOCKET_ERROR) {
		printf("shutdown() nije uspio: %d\n", WSAGetLastError());
		closesocket(ClientSocket);
		WSACleanup();
		return 1;
	}

	// ciscenje
	closesocket(ClientSocket);
	WSACleanup();

	system("PAUSE");

	return 0;
}

