/* tcpclient2.c
   prvo salje na jedan socket UDP pakete, iako je to
   TCP socket u serveru
   na drugi ne moze niti slati jer on nece moci listenati
   u serveru
   na treci salje TCP pakete (iako je socket UDP) */

#include<stdio.h>
#include<winsock2.h>
#include<windows.h>
#include<ws2tcpip.h>
#include<stdlib.h>

#define ADRESA "127.0.0.1"
#define HIVER 2
#define LOVER 2
#define PORT "27015"
#define PORT2 "27019"
#define DEFAULT_BUFLEN 512
#define SENDBUF 128

int main () {
	int getinfo, iResult;
	WSADATA wsadata;
	WORD wVersionRequested = MAKEWORD(HIVER, LOVER);
	ADDRINFOA *result = NULL, *ptr = NULL, hints;
	SOCKET ConnectSocket = INVALID_SOCKET;
	char *adresa = ADRESA, *port1 = PORT, *port2 = PORT2;
	int recvbuflen = DEFAULT_BUFLEN;
	char sendbuf[SENDBUF] = "Socket proba";
	char recvbuf[DEFAULT_BUFLEN];

	if (WSAStartup(wVersionRequested, &wsadata)!= 0) {
		printf("Nije moguce provjeriti verziju socketa\n");
		WSACleanup();
		return 1;
	}

	if (LOBYTE( wsadata.wVersion ) != HIVER ||
		HIBYTE( wsadata.wVersion ) != LOVER) {
			printf("Ne mogu naci winsock2.dll\n");
			WSACleanup();
			return 1;   
	}

	ZeroMemory(&hints, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	// sredjujem za prvi socket
	if (getaddrinfo(adresa, port1, &hints, &result)) {
		printf("getaddrinfo() nije uspjela\n");
		WSACleanup();
		return 1;
	}

	for (ptr=result; ptr != NULL ;ptr=ptr->ai_next) {
		// kreiraj socket za konekciju na server
		ConnectSocket = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol);
		if (ConnectSocket == INVALID_SOCKET) {
			printf("socket() nije uspjela: %ld\n", WSAGetLastError());
			freeaddrinfo(result);
			WSACleanup();
			return 1;
		}

		// spoji se
		iResult = connect(ConnectSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
		if (iResult == SOCKET_ERROR) {
			closesocket(ConnectSocket);
			ConnectSocket = INVALID_SOCKET;
			continue;
		}
		break;
	}

	freeaddrinfo(result);

	// gotov za prvi socket

	if (ConnectSocket == INVALID_SOCKET) {
		printf("Ne mogu se spojiti na server!\n");
		WSACleanup();
		return 1;
	}

	printf("Spojen na server!\n");

	// slanje podataka
	iResult = send(ConnectSocket, sendbuf, sizeof(sendbuf), 0);
	if (iResult == SOCKET_ERROR) {
		printf("Slanje neuspjesno!\n");
		closesocket(ConnectSocket);
		WSACleanup();
		return 1;
	}

	// shutdown ne zatvara socket, treba se izvrsiti closesocket()
	// onemogucava slanje i/ili primanje podataka
	// zastavice: 0 - zabrana primanja, 1 - zabrana slanja, 2 - oboje
	iResult = shutdown(ConnectSocket, SD_SEND);
	if (iResult == SOCKET_ERROR) {
		printf("shutdown() nije uspio: %d\n", WSAGetLastError());
		closesocket(ConnectSocket);
		WSACleanup();
		return 1;
	}

	// primaj podatke sve dok server ne zatvori konekciju
	do {
		iResult = recv(ConnectSocket, recvbuf, recvbuflen, 0);
		if (iResult > 0)
			printf("Primljeno: %d\n", iResult);
		else if (iResult == 0)
			printf("Konekcija zatvorena\n");
		else
			printf("Primanje neuspjesno: %d\n", WSAGetLastError());
	} while(iResult > 0);


	// konekcija gotova
	
	// treci socket
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;

	// sredjujem za prvi socket
	if (getaddrinfo(adresa, port1, &hints, &result)) {
		printf("getaddrinfo() nije uspjela\n");
		WSACleanup();
		return 1;
	}

	for (ptr=result; ptr != NULL ;ptr=ptr->ai_next) {
		// kreiraj socket za konekciju na server
		ConnectSocket = socket(ptr->ai_family, ptr->ai_socktype, ptr->ai_protocol);
		if (ConnectSocket == INVALID_SOCKET) {
			printf("socket() nije uspjela: %ld\n", WSAGetLastError());
			freeaddrinfo(result);
			WSACleanup();
			return 1;
		}

		// spoji se
		iResult = connect(ConnectSocket, ptr->ai_addr, (int)ptr->ai_addrlen);
		if (iResult == SOCKET_ERROR) {
			closesocket(ConnectSocket);
			ConnectSocket = INVALID_SOCKET;
			continue;
		}
		break;
	}

	freeaddrinfo(result);

	// gotov za prvi socket

	if (ConnectSocket == INVALID_SOCKET) {
		printf("Ne mogu se spojiti na server!\n");
		WSACleanup();
		return 1;
	}

	printf("Spojen na server!\n");

	// slanje podataka
	iResult = send(ConnectSocket, sendbuf, sizeof(sendbuf), 0);
	if (iResult == SOCKET_ERROR) {
		printf("Slanje neuspjesno!\n");
		closesocket(ConnectSocket);
		WSACleanup();
		return 1;
	}

	// shutdown ne zatvara socket, treba se izvrsiti closesocket()
	// onemogucava slanje i/ili primanje podataka
	// zastavice: 0 - zabrana primanja, 1 - zabrana slanja, 2 - oboje
	iResult = shutdown(ConnectSocket, SD_SEND);
	if (iResult == SOCKET_ERROR) {
		printf("shutdown() nije uspio: %d\n", WSAGetLastError());
		closesocket(ConnectSocket);
		WSACleanup();
		return 1;
	}

	// primaj podatke sve dok server ne zatvori konekciju
	do {
		iResult = recv(ConnectSocket, recvbuf, recvbuflen, 0);
		if (iResult > 0)
			printf("Primljeno: %d\n", iResult);
		else if (iResult == 0)
			printf("Konekcija zatvorena\n");
		else
			printf("Primanje neuspjesno: %d\n", WSAGetLastError());
	} while(iResult > 0);

	// ciscenje
	closesocket(ConnectSocket);
	WSACleanup();

	system("PAUSE");

	return 0;

}