/* tcpserver2.c
   tcpserver kreira 3 socketa,
   1. na portu 27015 i za protokol TCP, binda ga,
   i slusa na tom portu do konekcije
   2. na portu 27019 i za protokol TCP, ali ga ne binda,
   i pocinje odmah slusati
   3. na portu 27019, ali za UDP, binda ga i pokusava slusati */

#include<stdio.h>
#include<winsock2.h>
#include<windows.h>
#include<ws2tcpip.h>
#include<stdlib.h>

#define ADRESA "127.0.0.1"
#define ADRESA2 "10.0.10.4"
#define HIVER 2
#define LOVER 2
#define PORT "27015"
#define PORT2 "27019"
#define DEFAULT_BUFLEN 512

int main() {
	WSADATA wsadata;
	WORD wVersionRequested = MAKEWORD(HIVER, LOVER);
	ADDRINFOA *result, hints;
	SOCKET sockets[5], ClientSocket;
	int iResult, iSendResult;
	char recvbuf[DEFAULT_BUFLEN], sendbuf[DEFAULT_BUFLEN];
	char *port1 = PORT, *port2 = PORT2;

	if (WSAStartup(wVersionRequested, &wsadata)) {
		printf("Nema zahtijevane verzije winsock-a\n");
		WSACleanup();
		return 1;
	}

	if (LOBYTE(wsadata.wVersion) != LOVER ||
		HIBYTE(wsadata.wVersion) != HIVER) {
			printf("Ne mogu naci winsock2.dll\n");
			WSACleanup();
			return 1;   
	}

	ZeroMemory(&hints, sizeof(hints));
	// u hints stavljamo podatke o tipu socketa kakve server podrzava
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags = AI_PASSIVE; 

	// prevedi ime hosta u adresu
	iResult = getaddrinfo(NULL, port1, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo() nije uspjela: %d\n", iResult);
		WSACleanup();
		return 1;
	}

	// kreiranje prvoga socketa, slusa na 27015, TCP
	sockets[0] = socket(result->ai_family, result->ai_socktype, result->ai_protocol);
	if (sockets[0] == INVALID_SOCKET) {
		printf("Nije moguce kreirati socket: %ld\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 1;
	}

	printf("Socket1 kreiran...\n");

	// povezivanje socketa na zadani port i adresu
	if (bind(sockets[0], result->ai_addr, result->ai_addrlen)) {
		printf("Bind() nije uspjela, error: %d\n", WSAGetLastError());
		freeaddrinfo(result);
		WSACleanup();
		return 1;
	}

	printf("Socket1 povezan!\n");

	iResult = getaddrinfo(NULL, port2, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo() nije uspjela: %d\n", iResult);
		WSACleanup();
		return 1;
	}

	// kreiram drugi socket, za port 27019, TCP
	sockets[1] = socket(result->ai_family, result->ai_socktype, result->ai_protocol);

	printf("Socket2 kreiran...\n");

	hints.ai_socktype = SOCK_DGRAM;

	iResult = getaddrinfo(NULL, port2, &hints, &result);
	if (iResult != 0) {
		printf("getaddrinfo() nije uspjela: %d\n", iResult);
		WSACleanup();
		return 1;
	}

	// kreiram treci socket, za port 27019, UDP
	sockets[2] = socket(result->ai_family, result->ai_socktype, result->ai_protocol);

	printf("Socket3 kreiran...\n");

	bind(sockets[2], result->ai_addr, result->ai_addrlen);

	printf("Socket3 povezan...\n");

	freeaddrinfo(result);

	printf("Slusam za socket1...\n");

	// socket1 slusa, ok konfiguriran
	iResult = listen(sockets[0], SOMAXCONN);

	// prihvati klijentov socket
	ClientSocket = accept(sockets[0], NULL, NULL);

	closesocket(sockets[0]);

	do {
		iResult = recv(ClientSocket, recvbuf, DEFAULT_BUFLEN, 0);
		if (iResult > 0) {
			printf("Primljeno byteova: %d\n", iResult);
			printf("Primljeno: %s\n", recvbuf);

			strcpy(sendbuf, "dobio poruku");

			// salji podatke socketu1
			iSendResult = send(sockets[1], sendbuf, sizeof(sendbuf), 0 );
		}
		else if (iResult == 0)
			printf("Zatvaram konekciju...\n");

	} while (iResult > 0);

	// socket2 slusa, nije bindan
	iResult = listen(sockets[1], SOMAXCONN);

	// prihvati klijentov socket
	ClientSocket = accept(sockets[1], NULL, NULL);

	closesocket(sockets[1]);

	do {
		iResult = recv(ClientSocket, recvbuf, DEFAULT_BUFLEN, 0);
		if (iResult > 0) {
			printf("Primljeno byteova: %d\n", iResult);
			printf("Primljeno: %s\n", recvbuf);

			strcpy(sendbuf, "dobio poruku");

			// salji podatke klijentu
			iSendResult = send(ClientSocket, sendbuf, sizeof(sendbuf), 0 );
		}
		else if (iResult == 0)
			printf("Zatvaram konekciju...\n");

	} while (iResult > 0);

	// socket3 ceka na UDP
	iResult = listen(sockets[2], SOMAXCONN);

	// prihvati klijentov socket
	ClientSocket = accept(sockets[2], NULL, NULL);

	closesocket(sockets[2]);

	do {
		iResult = recv(ClientSocket, recvbuf, DEFAULT_BUFLEN, 0);
		if (iResult > 0) {
			printf("Primljeno byteova: %d\n", iResult);
			printf("Primljeno: %s\n", recvbuf);

			strcpy(sendbuf, "dobio poruku");

			// salji podatke klijentu
			iSendResult = send(ClientSocket, sendbuf, sizeof(sendbuf), 0 );
		}
		else if (iResult == 0)
			printf("Zatvaram konekciju...\n");

	} while (iResult > 0);

	// gasenje konekcije kad je gotovo
	// shutdown() onemogucuje slanje ili primanje podataka, ali ne zatvara socket
	iResult = shutdown(ClientSocket, SD_SEND);
	if (iResult == SOCKET_ERROR) {
		printf("shutdown() nije uspio: %d\n", WSAGetLastError());
		closesocket(ClientSocket);
		WSACleanup();
		return 1;
	}

	// ciscenje
	closesocket(ClientSocket);
	WSACleanup();

	system("PAUSE");

	return 0;
}

